<template>
  <div class="w-100 h-100">
    <slot v-if="ready">
      <leaflet-pane name="basemap" :zindex="190">
        <leaflet-tile-layer :url="$store.state.defaultBasemap"></leaflet-tile-layer>
      </leaflet-pane>
      <leaflet-pane name="borders" :zindex="300">
        <leaflet-wms-simple-layer
          url="http://mapservices.ipma.pt/common/boundaries/wms"
          name="coastlines">
        </leaflet-wms-simple-layer>
      </leaflet-pane>
      <leaflet-pane v-for="pane in mapPanes" :key="pane.id" :name="pane.name" :zindex="pane.zindex">
        <leaflet-wms-layer v-for="layer in layersInPane(pane)" :key="layer.layerProxyId"
          :identifier="layer.layerProxyId"
          :pane="pane.name">
        </leaflet-wms-layer>
      </leaflet-pane>
    </slot>
  </div>
</template>

<script>
import { map } from 'leaflet'
import LeafletPane from './LeafletPane'
import LeafletTileLayer from './LeafletTileLayer'
import LeafletWmsSimpleLayer from './LeafletWmsSimpleLayer'
import LeafletWmsLayer from './LeafletWmsLayer'

export default {
  name: 'leafletmap',

  data() {
    // We do this because we need to wait for the map to be mounted
    // first before we can start adding layers to it
    return { ready: false }
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    mapPanes: {
      get() {
        return Object.values(this.$store.getters.mapPanes)
      }
    },

    layers: {
      get() {
        return Object.values(this.$store.getters.workspaceLayers(this.workspace))
      }
    },
  },

  methods: {
    create() {
      this.leafletMap = map(this.$el, {
        zoom: 6,
        center: [37.5, -16]
      })
      this.ready = true
    },

    layersInPane(pane) {
      return this.layers.filter(layer => {
        return layer.pane === pane.id
      })
    },
  },

  mounted() {
    this.create()
  },

  components: {
    LeafletPane,
    LeafletTileLayer,
    LeafletWmsSimpleLayer,
    LeafletWmsLayer,
  }
}
</script>
